#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <getopt.h>
#include "vme_io.h"

int main(int argc, char **argv)
{
  char *Device = "/dev/vme_ctl";
  int Do_reset = 0;
  int Verbose = 0;
  int Vme_timeout = -1;
  for (;;)
    {
      int c;
      c = getopt(argc, argv, "d:t:rvh");
      switch(c)
	{
	case -1: break;
	case 'd': Device = optarg; break;
	case 't': Vme_timeout = atoi(optarg); break;
	case 'r': Do_reset = 1; break;
	case 'v': Verbose = 1; break;
	case 'h':
	default:
	  fprintf(stderr,"$Id: vme_ctl.c,v 1.1 1997/05/10 13:25:28 hannappe Exp $\nUsage: %s <options>\n"
		  "\t-d <file>\tdevice file name[%s]\n"
		  "\t-v\t\tbe more verbose\n"
		  "\t-h\t\tgive this (short) help\n"
		  "\t-t <usec>\tset VMEBus timeout\n"
		  "\t-r\t\tdo a vmebus-reset\n",
		  argv[0],
		  Device);
	  exit(1);
	}
      if (c== -1) break;
    }

  {
    int fd;

    fd = open(Device,O_RDWR);
    if (fd == -1 )
      { perror("mist"); exit(1);}
    if (Do_reset)
      {
	if (Verbose)
	  fprintf(stderr,"doing VME reset\n");
	ioctl(fd,VMECTL_RESET);
      }
    if (Vme_timeout > -1)
      {
	if (Verbose)
	  {
	    int value;
	    if (ioctl(fd,VMECTL_GETVMETO,&value))
	      perror("ioctl VMECTL_GETVMETO failed");
	    fprintf(stderr,"VME Timeout was %d usec\n",value);
	    fprintf(stderr,"setting VME Timeout to %d usec\n", Vme_timeout);
	  }
	if (ioctl(fd,VMECTL_SETVMETO,Vme_timeout))
	  perror("ioctl VMECTL_SETVMETO failed");
	if (Verbose)
	  {
	    int value;
	    if (ioctl(fd,VMECTL_GETVMETO,&value))
	      perror("ioctl VMECTL_GETVMETO failed");
	    fprintf(stderr,"VME Timeout is now %d usec\n",value);
	  }
      }
    close(fd);
    exit(0);
  }
}


/*
 * Local variables:
 * compile-command: "gcc -o vme_ctl -Wall vme_ctl.c"
 * End:
 */
