/*
  $Id: vme_io.h,v 1.7 1997/06/02 20:04:00 hannappe Exp $
 */
#ifndef __LINUX_VME_IO_H
#define __LINUX_VME_IO_H

#include <linux/ioctl.h>

/* ioctl()'s for the VME-Access */
/* first start with the control device (/dev/vme_ctl) which is used
   for operations affecting the entire bus, such as resetting, setting
   arbitration and so on */

/* execute a VMEBus reset */
#define VMECTL_RESET		_IO('x', 0)

/* get/set VMEBus time out, in usec */
#define VMECTL_GETVMETO		_IOR('x', 1, int)
#define VMECTL_SETVMETO		_IOW('x', 1, int)

#define VMEMAP_DWIDTH_8 (0)
#define VMEMAP_DWIDTH_16 (1)
#define VMEMAP_DWIDTH_32 (2)
#define VMEMAP_DWIDTH_64 (3)

#define VMEMAP_ASPACE_A16 (0)
#define VMEMAP_ASPACE_A24 (1)
#define VMEMAP_ASPACE_A32 (2)
#define VMEMAP_ASPACE_CRCSR (5)
#define VMEMAP_ASPACE_USR1 (6)
#define VMEMAP_ASPACE_USR2 (7)

#define VMEMAP_SUPUSERAM_USER (0)
#define VMEMAP_SUPUSERAM_SUPER (1)

#define VMEMAP_PRGDATAAM_DATA (0)
#define VMEMAP_PRGDATAAM_PRG (1)

struct vme_mapping_ctrl {
  char max_datawidth;
  char address_space;
  char supuseram;
  char prgdataam;
};

#define VMEIMG_GETMAPPING _IOR('x',2,struct vme_mapping_ctrl)
#define VMEIMG_SETMAPPING _IOW('x',2,struct vme_mapping_ctrl)

#define VMEIMG_GETVMEADDR _IOR('x',3,unsigned long)
#define VMEIMG_SETVMEADDR _IOW('x',3,unsigned long)

#define VMEIMG_GETGRANULARITY _IOR('x',4,unsigned long)



#define VMEIMG_GETDMATRESHOLD _IOR('x',5,unsigned long)
#define VMEIMG_SETDMATRESHOLD _IOW('x',5,unsigned long)

struct vme_irq_data_type {
  int nof_missed_interrupts;
  int vector_number;
};

struct vme_irq_mapping_type {
  unsigned char level;
  unsigned char vector;
};

#define VMEIRQ_GETLINK _IOR('x',6,struct vme_irq_mapping_type)
#define VMEIRQ_SETLINK _IOW('x',6,struct vme_irq_mapping_type)
#endif
